/// <reference types="react" />
import sendMail from "./emails";
import * as AccountCreatedPreview from "./emails/previews/AccountCreated";
import * as NewSignInPreview from "./emails/previews/NewSignIn";
import * as ReservationPreview from "./emails/previews/Reservation";
import * as ResetPasswordPreview from "./emails/previews/ResetPassword";
declare const previews: {
    AccountCreated: typeof AccountCreatedPreview;
    NewSignIn: typeof NewSignInPreview;
    Reservation: typeof ReservationPreview;
    ResetPassword: typeof ResetPasswordPreview;
};
declare const templates: {
    AccountCreated: import("react").FC<{
        name: string;
    }>;
    NewSignIn: import("react").FC<{
        name: string;
        headline: string;
        body: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>;
        bulletedList: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    }>;
    Reservation: import("react").FC<{
        headline: string;
        body: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>;
        bulletedList: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>;
        ctaText?: string | undefined;
    }>;
    ResetPassword: import("react").FC<{
        name: string;
        body: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>;
        ctaText: string;
    }>;
};
declare const config: {
    anonymousId: null;
};
export { sendMail, config, templates, previews };
declare const moduleManifest: {
    sendMail: (mail: import("packages/core/dist/mailing-core.cjs").ComponentMail) => Promise<import("nodemailer/lib/smtp-pool").SentMessageInfo | undefined>;
    config: {
        anonymousId: null;
    };
    templates: {
        AccountCreated: import("react").FC<{
            name: string;
        }>;
        NewSignIn: import("react").FC<{
            name: string;
            headline: string;
            body: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>;
            bulletedList: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>;
        }>;
        Reservation: import("react").FC<{
            headline: string;
            body: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>;
            bulletedList: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>;
            ctaText?: string | undefined;
        }>;
        ResetPassword: import("react").FC<{
            name: string;
            body: import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>>;
            ctaText: string;
        }>;
    };
    previews: {
        AccountCreated: typeof AccountCreatedPreview;
        NewSignIn: typeof NewSignInPreview;
        Reservation: typeof ReservationPreview;
        ResetPassword: typeof ResetPasswordPreview;
    };
};
export default moduleManifest;
